/*
 *    Copyright (C) 2002  Michael Bakunin - bakunin@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <elf.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>


#define MAX 10

int main(int argc, char *argv[]) {
   char *data;
   Elf32_Ehdr efd;
   int fd,fd2,fd3,n,r;
   struct stat stat,stat2;
  
   switch(argc) {
      case 3:

         if((fd = open(argv[1], O_RDONLY, 0)) < 0) 
                              { puts("Errore di apertura argv[1]"); return 1; }
         if(read(fd, &efd, sizeof(efd))!=sizeof(efd)) 
                            { puts("Errore di lettura su argv[1]"); return 1; }

         if(
            efd.e_ident[0] != ELFMAG0 ||
            efd.e_ident[1] != ELFMAG1 ||
            efd.e_ident[2] != ELFMAG2 ||
            efd.e_ident[3] != ELFMAG3
         ) 
                                { puts("Tipologia di file errato"); return 1; }

         if(efd.e_type != ET_EXEC && efd.e_type != ET_DYN)    
                                { puts("Tipologia di file errato"); return 1; }
         if(efd.e_machine != EM_386)  
                                { puts("Tipologia di file errato"); return 1; }
         if(efd.e_version != EV_CURRENT)  
                                { puts("Tipologia di file errato"); return 1; }
         if(fstat(fd, &stat) < 0) 
                                    { puts("fstat ha dato errore"); return 1; }

         if((fd2 = open(argv[2], O_RDONLY, 0)) < 0)    
                              { puts("Errore di apertura argv[2]"); return 1; }
         if(fstat(fd2, &stat2) < 0)          
                                    { puts("fstat ha dato errore"); return 1; }

         if(stat2.st_size > stat.st_size)
           { puts("Il messaggio deve essere pi piccolo dell'elf"); return 1; }

         if(!(data=(char *)malloc(sizeof(char)*(strlen(argv[1])+4)))) 
                                   { puts("Errore di allocazione"); return 1; }
         sprintf(data,"%s.new",argv[1]);

         if((fd3 = open(data,O_RDWR | O_CREAT | O_TRUNC,stat.st_mode))<0) 
                                   { puts("Errore scrittura file"); return 1; }
         free(data);

         if(write(fd3, puff, sizeof(puff)) != sizeof(puff)) 
                                   { puts("Errore scrittura file"); return 1; }
         if(!(data=(char *)malloc(sizeof(off_t))))   
                                   { puts("Errore di allocazione"); return 1; }

         sprintf(data,"%dp",(int)stat2.st_size);

         if(write(fd3, data, strlen(data)) != strlen(data))
                                   { puts("Errore scrittura file"); return 1; }
         free(data);

         n = stat.st_size / (stat2.st_size + 1);
         r = stat2.st_size;

#ifdef DEBUG
         printf("Rapporto programma / messaggio: - %d -\n",n);
         printf("Caratteri messaggio: - %d -\n",r);
#endif

         if(!(data=(char *)malloc(n*sizeof(char))))     
                                   { puts("Errore di allocazione"); return 1; }

         if(lseek(fd,0,SEEK_SET)!=0)
                                    { puts("Errore gestione file"); return 1; }

         while(r--) {
           if(read(fd, data, n) != n)  
                                    { puts("Errore lettura file1"); return 1; }
           if(write(fd3, data, n) != n) 
                                  { puts("Errore scrittura file2"); return 1; }
           if(read(fd2, data, 1) != 1)
                                    { puts("Errore lettura file3"); return 1; }
           if(write(fd3, data, 1) != 1)
                                  { puts("Errore scrittura file4"); return 1; }
#ifdef DEBUG
           printf("Inserisco il carattere numero %d: - %c -\n",r,data[0]);
#endif
         }

         free(data);

         while(1) {
           if(read(fd, data, 1) != 1) break;
           if(write(fd3, data, 1) != 1)
                                   { puts("Errore scrittura file"); return 1; }
         }

         return 0;
      default: 
                             { puts("Dammi un elf e un messaggio"); return 1; }
   }
}
