#define PUFF 6625
/*
 *    Copyright (C) 2002  Michael Bakunin - bakunin@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>


#define TMP_F ".tmp_f"
#define MAX 10

int main(int argc, char *argv[], char *envp[]) {

   struct stat stat;
   char key[MAX],data[1];
   int fd,fd2;
   int n,len,msg;

   if((fd = open(argv[0], O_RDONLY, 0)) < 0)                       return 1;
   if(lseek(fd, PUFF, SEEK_SET)!= PUFF)                            return 1;

   n=0;
   do {
     if(read(fd,data,1)!=1)                                        return 1;
     key[n++]=data[0];
     if(n==MAX-1) break;
   } while(data[0]!='p');

   if(key[n-1]=='p') key[n-1]=0;
   else              key[n]=0;

   msg=atoi(key);

#ifdef DEBUG
   printf("Lunghezza messaggio: - %d -\n",msg++);
#endif

   if(fstat(fd, &stat)<0)                                          return 1;

   len = stat.st_size - (PUFF + msg + 3);

#ifdef DEBUG
   printf("Lunghezza programma: - %d -\n",len);
#endif

   n=len/msg;

   if(argc>1 && !strcmp(argv[1],"--puff")) {
     while(--msg) {
       int i;
       for(i=0;i<n;i++) 
         if(read(fd, key, 1) != 1)                                return 1;

       if(read(fd, key, 1) != 1)                                  return 1;
       putchar(key[0]);
     }
     close(fd); 
     return 0;
   } 

   if((fd2=open(TMP_F,O_RDWR | O_CREAT | O_TRUNC,stat.st_mode))<0) return 1;

   while(--msg) {
     int i;
     for(i=0;i<n;i++) {
       if(read(fd, key, 1) != 1)                                   return 1;
       if(write(fd2, key, 1) != 1)                                 return 1;
     }
     if(read(fd, key, 1) != 1)                                     return 1;
   }

   while(1) {
     if(read(fd, key, 1) != 1) break;
     if(write(fd2, key, 1) != 1)                                   return 1;
   }

   close(fd);
   close(fd2);

   execve(TMP_F, argv, envp);
   unlink(TMP_F);

   return 0;
}
